#include "Board.h"
#include "Field.h"

template<> Board<Field>::Board(std::FILE* file) :
    m_width(0), m_height(0)
{
    int ch = 0;
    uint32_t line_width = 0;
    while((ch = fgetc(file)) != EOF)
    {
        if (ch == '\n')
        {
            m_height += 1;
            if (line_width != m_width) throw BoardException("Invalid line width");
            line_width = 0;
            continue;
        }

        line_width += 1;
        if (m_height == 0) { m_width += 1; }
        const Field f = char_to_field((char)ch);
        if (f == F_SAFE || f == F_DEADLY) throw BoardException("Invalid input field specifier");
        m_data.push_back(f);
    }
    if (line_width != 0)
    {
        if (line_width != m_width) throw BoardException("Invalid line width");
        m_height += 1;
    }
}